"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var index_1 = require("../../base/index");
var index_2 = require("../../base/index");
var log_filter_1 = require("../shared/data/log.filter");
var index_3 = require("../../shared/index");
var message_service_1 = require("../../shared/service/message.service");
var session_shared_service_1 = require("../../shared/service/session-shared.service");
var LogListFilterComponent = (function (_super) {
    __extends(LogListFilterComponent, _super);
    function LogListFilterComponent(formBuilder, messageService, sessionShared) {
        var _this = _super.call(this) || this;
        _this.formBuilder = formBuilder;
        _this.messageService = messageService;
        _this.sessionShared = sessionShared;
        //gestión del filtro. TO-DO: ¿A BaseListFilter?
        //gestión del filtro. TO-DO: ¿A BaseListFilter?
        _this.filter = _this.sessionShared.get("LOG_FILTER") || _this.createNewFilter();
        _this.sessionShared.set("LOG_FILTER", _this.filter);
        //siempre que iniciamos el componente restauramos la página y el número de elementos por página. TO-DO: ¿A BaseListFilter?
        //siempre que iniciamos el componente restauramos la página y el número de elementos por página. TO-DO: ¿A BaseListFilter?
        _this.filter.pagina = index_1.BaseFilter.PAGE;
        _this.filter.resultados = index_1.BaseFilter.RESULTADOS_PAGE;
        //construimos el form
        //construimos el form         
        _this.myForm = formBuilder.group({
            'fecha': [_this.filter.fecha, [forms_1.Validators.required, index_3.CustomValidators.dataValidator]],
            'desde': [_this.filter.desde, [forms_1.Validators.required]],
            //CustomValidators.timeValidator
            'hasta': [_this.filter.hasta, [forms_1.Validators.required]],
            //CustomValidators.timeValidator
            'login': [_this.filter.login, [forms_1.Validators.required]]
        });
        return _this;
    }
    /** Crea un nuevo filtro para realizar la búsqueda */
    /** Crea un nuevo filtro para realizar la búsqueda */
    LogListFilterComponent.prototype.createNewFilter = /** Crea un nuevo filtro para realizar la búsqueda */
    function () {
        return log_filter_1.LogFilter.newObject();
    };
    LogListFilterComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'log-list-filter',
                    template: "\n      <div class=\"panel panel-filtro\" [hidden]=\"!displayFilter\">\n          <div class=\"panel-heading\">\n              <i></i>&nbsp;&nbsp;&nbsp;Filtre de cerca:\n          </div>\n          <form role=\"form\" [formGroup]=\"myForm\" (submit)=\"submit(myForm.value)\">\n              <div class=\"panel-body\">\n                  <div class=\"row\">\n                      <div class=\"col-xs-2\">\n                          <bit-input [(ngModel)]=\"filter.fecha\" nombre=\"fecha\" [control]=\"myForm.controls.fecha\" formControlName=\"fecha\" tipo=\"date\">&nbsp;&nbsp;Data</bit-input>\n                      </div>\n                      <div class=\"col-xs-2\">\n                          <bit-input [(ngModel)]=\"filter.desde\" nombre=\"desde\" [control]=\"myForm.controls.desde\" formControlName=\"desde\" tipo=\"time\">&nbsp;&nbsp;Des de</bit-input>\n                      </div>\n                      <div class=\"col-xs-2\">\n                          <bit-input [(ngModel)]=\"filter.hasta\" nombre=\"hasta\" [control]=\"myForm.controls.hasta\" formControlName=\"hasta\" tipo=\"time\">&nbsp;&nbsp;Fins a</bit-input>\n                      </div>\n                      <div class=\"col-xs-2\">\n                          <bit-input [(ngModel)]=\"filter.login\" nombre=\"login\" [control]=\"myForm.controls.login\" formControlName=\"login\" tipo=\"text\" >&nbsp;&nbsp;Login</bit-input>\n                      </div>\n                      <div class=\"col-xs-2\">\n                          <bit-select domain=\"tipoLog\" id=\"tipolog\" [filter]=\"false\" [(ngModel)]=\"filter.tipoLog\" [ngModelOptions]=\"{standalone: true}\">&nbsp;&nbsp;Tipus d'operació</bit-select>\n                      </div>\n                      <div class=\"col-xs-2\">\n                          <bit-input [(ngModel)]=\"filter.mostrarErrores\" nombre=\"mostrarErrores\" [ngModelOptions]=\"{standalone: true}\" tipo=\"checkbox\">Només errors</bit-input>\n                      </div>\n                  </div>\n              </div>\n              <div class=\"panel-footer text-center\">\n                  <div class=\"btn-group\" role=\"group\">\n                      <button type=\"reset\" (click)=\"resetFilter()\" class=\"btn btn-default\" >Neteja&nbsp;&nbsp;<span class=\"glyphicon glyphicon-erase\"></span></button>\n                  </div>\n                  <div class=\"btn-group\" role=\"group\">\n                      <button type=\"submit\" class=\"btn btn-success\">Cerca&nbsp;&nbsp;<span class=\"glyphicon glyphicon-search\"></span></button>\n                  </div>\n              </div>\n          </form>\n      </div>\n    "
                },] },
    ];
    /** @nocollapse */
    LogListFilterComponent.ctorParameters = function () { return [
        { type: forms_1.FormBuilder, },
        { type: message_service_1.MessageService, },
        { type: session_shared_service_1.SessionSharedService, },
    ]; };
    return LogListFilterComponent;
}(index_2.BaseFilterComponent));
exports.LogListFilterComponent = LogListFilterComponent;
//# sourceMappingURL=log-list-filter.component.js.map