import { EventEmitter } from '@angular/core';
import { FormControl } from '@angular/forms';
import { AyudaService } from '../service/ayuda.service';
import { ControlValueAccessor } from '@angular/forms';
export declare const CUSTOM_BITEDITOR_CONTROL_VALUE_ACCESSOR: any;
/**
* Clase que utiliza un custom componente para campo editor de HTML
* Utiliza la interfaz ControlValueAccessor
*    <bit-editor [(ngModel)]="object.descripcion" [ngModelOptions]="{standalone: true}" height="250">&nbsp;&nbsp;Descripció</bit-editor>
* Para utilizar, importar tambien js y css.
**/
export declare class BitEditorComponent implements ControlValueAccessor {
    protected ayudaService: AyudaService;
    control: FormControl;
    nombre: any;
    label: string;
    tipo: String;
    placeholder: string;
    readOnly: boolean;
    height: number;
    hideLabel: boolean;
    onChange: EventEmitter<string>;
    private forceObligatorio;
    private innerValue;
    private onTouchedCallback;
    private onChangeCallback;
    constructor(ayudaService: AyudaService);
    value: any;
    readonly value_lectura: string;
    changed(event: any): void;
    writeValue(value: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    readonly obligatorio: boolean;
}
