"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("@angular/core");
var forms_1 = require("@angular/forms");
var ayuda_service_1 = require("../service/ayuda.service");
var forms_2 = require("@angular/forms");
var noop = function () { };
var ɵ0 = noop;
exports.ɵ0 = ɵ0;
exports.CUSTOM_BITEDITOR_CONTROL_VALUE_ACCESSOR = {
    provide: forms_2.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return BitEditorComponent; }),
    multi: true
};
/**
* Clase que utiliza un custom componente para campo editor de HTML
* Utiliza la interfaz ControlValueAccessor
*    <bit-editor [(ngModel)]="object.descripcion" [ngModelOptions]="{standalone: true}" height="250">&nbsp;&nbsp;Descripció</bit-editor>
* Para utilizar, importar tambien js y css.
**/
var BitEditorComponent = (function () {
    function BitEditorComponent(ayudaService) {
        this.ayudaService = ayudaService;
        this.tipo = "completo";
        this.placeholder = '';
        this.readOnly = false;
        this.height = 100;
        this.hideLabel = false;
        this.onChange = new core_2.EventEmitter();
        this.forceObligatorio = false;
        this.innerValue = '';
        this.onTouchedCallback = noop;
        this.onChangeCallback = noop;
    }
    Object.defineProperty(BitEditorComponent.prototype, "value", {
        //get accessor
        get: 
        //get accessor
        function () {
            return this.innerValue;
        },
        //set accessor including call the onchange callback
        set: 
        //set accessor including call the onchange callback
        function (v) {
            if (v !== this.innerValue) {
                this.innerValue = v;
            }
            this.onChangeCallback(v);
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(BitEditorComponent.prototype, "value_lectura", {
        get: function () {
            if (this.value == null) {
                return "";
            }
            else {
                return this.value;
            }
        },
        enumerable: true,
        configurable: true
    });
    BitEditorComponent.prototype.changed = function (event) {
        this.onTouchedCallback();
        this.onChangeCallback(this.innerValue);
        this.onChange.emit(event);
    };
    BitEditorComponent.prototype.writeValue = function (value) {
        if (value !== this.innerValue) {
            this.innerValue = value;
        }
    };
    BitEditorComponent.prototype.registerOnChange = function (fn) {
        this.onChangeCallback = fn;
    };
    BitEditorComponent.prototype.registerOnTouched = function (fn) {
        this.onTouchedCallback = fn;
    };
    Object.defineProperty(BitEditorComponent.prototype, "obligatorio", {
        // decidimos marcar el campo como obligatorio si se ha indicado a la fuerza (por parámetro)
        // o si el control de formulario asociado está saltando por ser obligatorio y no haberse rellenado
        get: 
        // decidimos marcar el campo como obligatorio si se ha indicado a la fuerza (por parámetro)
        // o si el control de formulario asociado está saltando por ser obligatorio y no haberse rellenado
        function () {
            return this.forceObligatorio || (this.control && this.control.errors && this.control.errors['required']);
        },
        enumerable: true,
        configurable: true
    });
    BitEditorComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'bit-editor',
                    template: "\n            <label *ngIf=\"!hideLabel\"><ng-content></ng-content>&nbsp;<span *ngIf=\"obligatorio\" class=\"obligatorio fa fa-asterisk\"></span>&nbsp;&nbsp;<i *ngIf=\"ayuda\" class=\"btn-ayuda fa fa-question\" (click)=\"showAyuda();\"></i></label>\n            <p *ngIf=\"tipo.indexOf('lectura') == 0 || readOnly\" class=\"lectura\">\n                {{(value_lectura && value_lectura!='')?value_lectura:'&nbsp;'}}\n            </p>\n            <p-editor styleClass=\"editor\" id=\"{{nombre}}\" name=\"{{nombre}}\" \n                *ngIf=\"!readOnly && tipo=='simple'\" [(ngModel)]=\"value\"\n                    [placeholder]=\"placeholder\" [style]=\"{'height':height+'px'}\">\n                    <p-header>\n                    <span class=\"ql-formats\">\n                        <button class=\"ql-bold\" aria-label=\"Bold\"></button>\n                        <button class=\"ql-italic\" aria-label=\"Italic\"></button>\n                        <button class=\"ql-underline\" aria-label=\"Underline\"></button>\n                    </span>\n                </p-header>\n            </p-editor>\n            <p-editor styleClass=\"editor\" id=\"{{nombre}}\" name=\"{{nombre}}\" \n                *ngIf=\"!readOnly && (!tipo || tipo=='completo')\" [(ngModel)]=\"value\"\n                    [placeholder]=\"placeholder\" [style]=\"{'height':height+'px'}\">\n            </p-editor>\n            <control-messages *ngIf=\"control!=null && !readOnly\" [control]=\"control\" [field]=\"nombre\"></control-messages>\n",
                    providers: [exports.CUSTOM_BITEDITOR_CONTROL_VALUE_ACCESSOR]
                },] },
    ];
    /** @nocollapse */
    BitEditorComponent.ctorParameters = function () { return [
        { type: ayuda_service_1.AyudaService, },
    ]; };
    BitEditorComponent.propDecorators = {
        "control": [{ type: core_2.Input },],
        "nombre": [{ type: core_2.Input },],
        "label": [{ type: core_2.Input },],
        "tipo": [{ type: core_2.Input },],
        "placeholder": [{ type: core_2.Input },],
        "readOnly": [{ type: core_2.Input },],
        "height": [{ type: core_2.Input },],
        "hideLabel": [{ type: core_2.Input },],
        "onChange": [{ type: core_2.Output },],
        "forceObligatorio": [{ type: core_2.Input },],
    };
    return BitEditorComponent;
}());
exports.BitEditorComponent = BitEditorComponent;
//# sourceMappingURL=bit-editor.component.js.map