"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("@angular/core");
var forms_1 = require("@angular/forms");
var ayuda_service_1 = require("../service/ayuda.service");
var general_utils_service_1 = require("../service/general-utils.service");
var forms_2 = require("@angular/forms");
var noop = function () { };
var ɵ0 = noop;
exports.ɵ0 = ɵ0;
exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR = {
    provide: forms_2.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return BitInputComponent; }),
    multi: true
};
/** TODO: cambiar algunas propiedades que están en castellano como nombre, tipo al inglés: name, type
* Clase que utiliza un custom componente para input text sencillos
* Utiliza la interfaz ControlValueAccessor
*    <bit-input2 [(ngModel)]="filter.fecha"
*       [nombre]="'fecha2'" [control]="myForm.controls.fecha" formControlName="fecha" [tipo]="'date'" >&nbsp;&nbsp;fecha</bit-input2>
*    <bit-input2 [(ngModel)]="filter.login"
*       [nombre]="'login'" [control]="myForm.controls.login" formControlName="login" [tipo]="'text'" >&nbsp;&nbsp;login</bit-input2>
**/
var BitInputComponent = (function () {
    function BitInputComponent(ayudaService) {
        this.ayudaService = ayudaService;
        this.placeholder = '';
        this.readOnly = false;
        this.hideLabel = false;
        this.disabled = false;
        this.completeMethod = new core_2.EventEmitter();
        this.onSelect = new core_2.EventEmitter();
        this.onChange = new core_2.EventEmitter();
        this.forceObligatorio = false;
        this.innerValue = '';
        this.onTouchedCallback = noop;
        this.onChangeCallback = noop;
        this.LOCALE_ES = {
            firstDayOfWeek: 1,
            closeText: "Cerrar",
            prevText: "<Ant",
            nextText: "Sig>",
            currentText: "Hoy",
            monthNames: ["enero", "febrero", "marzo", "abril", "mayo", "junio",
                "julio", "agosto", "septiembre", "octubre", "noviembre", "diciembre"],
            monthNamesShort: ["ene", "feb", "mar", "abr", "may", "jun",
                "jul", "ago", "sep", "oct", "nov", "dic"],
            dayNames: ["domingo", "lunes", "martes", "miércoles", "jueves", "viernes", "sábado"],
            dayNamesShort: ["dom", "lun", "mar", "mié", "jue", "vie", "sáb"],
            dayNamesMin: ["D", "L", "M", "X", "J", "V", "S"],
            weekHeader: "Sm",
            dateFormat: "dd/mm/yy",
            firstDay: 1,
            isRTL: false,
            showMonthAfterYear: false,
            yearSuffix: "",
            timeOnlyTitle: 'Elegir una hora',
            timeText: 'Hora',
            hourText: 'Horas',
            minuteText: 'Minutos',
            secondText: 'Segundos',
            millisecText: 'Milisegundos',
            microsecText: 'Microsegundos',
            timezoneText: 'Uso horario',
            timeFormat: 'HH:mm',
            timeSuffix: '',
            amNames: ['a.m.', 'AM', 'A'],
            pmNames: ['p.m.', 'PM', 'P']
        };
    }
    Object.defineProperty(BitInputComponent.prototype, "value", {
        //get accessor
        get: 
        //get accessor
        function () {
            return this.innerValue;
        },
        //set accessor including call the onchange callback
        set: 
        //set accessor including call the onchange callback
        function (v) {
            if (this.tipo === 'date') {
                //hacemos una reconversion de la fecha a formato corto. La versión final de Prime nos entrega el formato ISO
                //console.log("Valor para la fecha en formato largo {}",v);
                if (v) {
                    v = general_utils_service_1.GeneralUtils.getDateAsString(general_utils_service_1.GeneralUtils.stringToDate(v));
                }
                //console.log("Nuevo valor para la fecha {}",v);
            }
            if (this.tipo === 'time') {
                //hacemos una reconversion de la fecha a formato corto. La versión final de Prime nos entrega el formato ISO
                //console.log("Valor para la fecha en formato largo {}",v);
                if (v) {
                    v = general_utils_service_1.GeneralUtils.getTimeAsString(general_utils_service_1.GeneralUtils.stringToDate(v));
                }
                //console.log("Nuevo valor para la fecha {}",v);
            }
            if (this.tipo === 'datetime') {
                //hacemos una reconversion de la fecha a formato corto. La versión final de Prime nos entrega el formato ISO
                //console.log("Valor para la fecha en formato largo {}",v);
                if (v) {
                    v = general_utils_service_1.GeneralUtils.getDateTimeAsString(v);
                }
                //console.log("Nuevo valor para la fecha {}",v);
            }
            if (v !== this.innerValue) {
                this.innerValue = v;
            }
            this.onChangeCallback(v);
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(BitInputComponent.prototype, "value_lectura", {
        get: function () {
            if (this.value == null) {
                return "";
            }
            else if (this.tipo === 'lectura-date') {
                return general_utils_service_1.GeneralUtils.getDateAsString(general_utils_service_1.GeneralUtils.stringToDate(this.value));
            }
            else if (this.tipo === 'lectura-time') {
                return general_utils_service_1.GeneralUtils.getTimeAsString(general_utils_service_1.GeneralUtils.stringToDate(this.value));
            }
            else if (this.tipo === 'lectura-datetime') {
                return general_utils_service_1.GeneralUtils.getDateTimeAsString(general_utils_service_1.GeneralUtils.stringToDate(this.value));
            }
            else if (this.tipo === 'datetime') {
                return general_utils_service_1.GeneralUtils.getDateTimeAsString(this.value);
            }
            else if (this.value === true) {
                return "Sí";
            }
            else if (this.value === false) {
                return "No";
            }
            else {
                return this.value;
            }
        },
        enumerable: true,
        configurable: true
    });
    BitInputComponent.prototype.changed = function (event) {
        this.onTouchedCallback();
        this.onChangeCallback(this.innerValue);
        this.onChange.emit(event);
    };
    BitInputComponent.prototype.onBlur = function () {
        if (this.instanciaPipe != null) {
            this.innerValue = this.instanciaPipe.transform(this.innerValue);
        }
        this.onTouchedCallback();
    };
    BitInputComponent.prototype.onFocus = function () {
        if (this.instanciaPipe != null) {
            this.innerValue = this.instanciaPipe.parse(this.innerValue);
            this.control.updateValueAndValidity();
        }
        this.onTouchedCallback();
        this.onChangeCallback(this.innerValue);
    };
    BitInputComponent.prototype.writeValue = function (value) {
        if (value !== this.innerValue) {
            this.innerValue = value;
        }
    };
    BitInputComponent.prototype.registerOnChange = function (fn) {
        this.onChangeCallback = fn;
    };
    BitInputComponent.prototype.registerOnTouched = function (fn) {
        this.onTouchedCallback = fn;
    };
    BitInputComponent.prototype.search = function (event) {
        this.completeMethod.emit(event);
    };
    BitInputComponent.prototype.selectValue = function (event) {
        this.onSelect.emit(event);
    };
    Object.defineProperty(BitInputComponent.prototype, "obligatorio", {
        // decidimos marcar el campo como obligatorio si se ha indicado a la fuerza (por parámetro)
        // o si el control de formulario asociado está saltando por ser obligatorio y no haberse rellenado
        get: 
        // decidimos marcar el campo como obligatorio si se ha indicado a la fuerza (por parámetro)
        // o si el control de formulario asociado está saltando por ser obligatorio y no haberse rellenado
        function () {
            return this.forceObligatorio || (this.control && this.control.errors && this.control.errors['required']);
        },
        enumerable: true,
        configurable: true
    });
    BitInputComponent.prototype.showAyuda = function () {
        this.ayudaService.mostrarAyuda(this.ayuda);
    };
    BitInputComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    BitInputComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'bit-input',
                    template: "\n            <label *ngIf=\"!hideLabel && tipo!='checkbox' && tipo!='oculto'\"><ng-content></ng-content>&nbsp;<span *ngIf=\"obligatorio\" class=\"obligatorio fa fa-asterisk\"></span>&nbsp;&nbsp;<i *ngIf=\"ayuda\" class=\"btn-ayuda fa fa-question\" (click)=\"showAyuda();\"></i></label>\n            <p *ngIf=\"tipo.indexOf('lectura') == 0 || readOnly\" class=\"lectura\">\n                {{(value_lectura && value_lectura!='')?value_lectura:'&nbsp;'}}\n            </p>\n           \n            <input *ngIf=\"tipo=='text' && !tooltiptexto && !readOnly\" \n                    type=\"text\" class=\"form-control\" [(ngModel)]=\"value\"  id=\"{{nombre}}\" name=\"{{nombre}}\"\n                    (ngModelChange)=\"changed($event)\"\n                    [attr.directive]=\"nombreDirectiva\" (blur)=\"onBlur()\" (focus)=\"onFocus()\"\n                    [placeholder]=\"placeholder\" />\n            <input *ngIf=\"tipo=='text' && tooltiptexto && !readOnly\" \n                    type=\"text\" class=\"form-control\" [(ngModel)]=\"value\"  id=\"{{nombre}}\" name=\"{{nombre}}\" \n                    (ngModelChange)=\"changed($event)\"\n                    [attr.directive]=\"nombreDirectiva\" (blur)=\"onBlur()\" (focus)=\"onFocus()\" [pTooltip]=\"tooltiptexto\" [tooltipPosition]=\"tooltipposicion\" />\n            <input *ngIf=\"tipo=='oculto' && !readOnly\"\n                    type=\"hidden\" [(ngModel)]=\"value\"  id=\"{{nombre}}\" name=\"{{nombre}}\" \n                    (ngModelChange)=\"changed($event)\"\n                    [attr.directive]=\"nombreDirectiva\" />\n            <textarea pInputTextarea *ngIf=\"tipo=='textarea' && !readOnly\" class=\"form-control h-100 {{estilo}}\" [(ngModel)]=\"value\" id=\"{{nombre}}\" name=\"{{nombre}}\"\n                    (ngModelChange)=\"changed($event)\"\n                    (blur)=\"onBlur()\" (focus)=\"onFocus()\"></textarea>\n            <p-checkbox class=\"{{estilo}}\" *ngIf=\"tipo=='checkbox' && !readOnly\" binary=\"true\" [(ngModel)]=\"value\" [label]=\"!hideLabel && label\" name=\"{{nombre}}\" id=\"{{nombre}}\" [disabled]=\"disabled\"></p-checkbox>\n            <i *ngIf=\"ayuda && tipo=='checkbox' && !readOnly\" (click)=\"showAyuda();\"class=\"btn-ayuda-checkbox fa fa-question\"></i>\n            <p-radioButton  class=\"{{estilo}}\" *ngIf=\"tipo=='radiobutton' && !readOnly\" binary=\"true\" [(ngModel)]=\"value\" [label]=\"!hideLabel && label\" name=\"{{nombre}}\" value=\"{{valueRadioButton}}\" id=\"{{nombre}}\"\n                    (ngModelChange)=\"changed($event)\" [disabled]=\"disabled\"></p-radioButton>\n\n            <p-calendar *ngIf=\"tipo=='date' && !readOnly\" class=\"FormControl\" [(ngModel)]=\"value\" id=\"{{nombre}}\" name=\"{{nombre}}\"                        \n                    (ngModelChange)=\"changed($event)\"\n                    dateFormat=\"dd/mm/yy\" placeholder=\"dd/mm/yyyy\" [monthNavigator]=\"true\" [readonlyInput]=\"calendarReadOnlyInput\"\n                    [minDate]=\"fechaMinima\" [maxDate]=\"fechaMaxima\"\n                    [yearNavigator]=\"true\" yearRange=\"2000:2030\" [locale]=\"LOCALE_ES\"></p-calendar>\n            <p-calendar *ngIf=\"tipo=='datetime' && !readOnly\" class=\"FormControl\" [(ngModel)]=\"value\" id=\"{{nombre}}\" name=\"{{nombre}}\"                        \n                    (ngModelChange)=\"changed($event)\"\n                    dateFormat=\"dd/mm/yy\" placeholder=\"dd/mm/yyyy hh:mm\" [monthNavigator]=\"true\"\n                    [minDate]=\"fechaMinima\" [maxDate]=\"fechaMaxima\"\n                    [yearNavigator]=\"true\" yearRange=\"2000:2030\" [locale]=\"LOCALE_ES\" [showTime]=\"true\"></p-calendar>\n            <span *ngIf=\"tipo=='date' && !readOnly\" class=\"glyphicon glyphicon-calendar icono-input\"></span>\n            <span *ngIf=\"tipo=='datetime' && !readOnly\" class=\"glyphicon glyphicon-calendar icono-input\"></span>\n            <p-calendar *ngIf=\"tipo=='time' && !readOnly\" class=\"FormControl\" [(ngModel)]=\"value\"   id=\"{{nombre}}\" name=\"{{nombre}}\"                        \n                    (ngModelChange)=\"changed($event)\"\n                    timeFormat=\"HH:mm\" [timeOnly]=\"true\" placeholder=\"HH:mm\" [locale]=\"LOCALE_ES\"></p-calendar>\n            <p-autoComplete *ngIf=\"tipo=='autocomplete' && !readOnly\" [(ngModel)]=\"value\" id=\"{{nombre}}\" name=\"{{nombre}}\" [placeholder]=\"placeholder\"\n                    (ngModelChange)=\"changed($event)\"\n                    [suggestions]=\"suggestions\" [field]=\"suggestionField\" (completeMethod)=\"search($event)\" (onSelect)=\"selectValue($event)\" (blur)=\"onBlur()\" (focus)=\"onFocus()\" [multiple]=\"multiple\"></p-autoComplete>\n            <p-inputSwitch *ngIf=\"tipo=='switch' && !readOnly\" onLabel=\"S\u00ED\" offLabel=\"No\" binary=\"true\" [(ngModel)]=\"value\" (ngModelChange)=\"changed($event)\" name=\"{{nombre}}\" id=\"{{nombre}}\"></p-inputSwitch>\n            <control-messages *ngIf=\"control!=null && !readOnly\" [control]=\"control\" [field]=\"nombre\"></control-messages>\n",
                    providers: [exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR]
                },] },
    ];
    /** @nocollapse */
    BitInputComponent.ctorParameters = function () { return [
        { type: ayuda_service_1.AyudaService, },
    ]; };
    BitInputComponent.propDecorators = {
        "control": [{ type: core_2.Input },],
        "nombre": [{ type: core_2.Input },],
        "nombreDirectiva": [{ type: core_2.Input },],
        "label": [{ type: core_2.Input },],
        "tipo": [{ type: core_2.Input },],
        "estilo": [{ type: core_2.Input },],
        "tooltiptexto": [{ type: core_2.Input },],
        "tooltipposicion": [{ type: core_2.Input },],
        "ayuda": [{ type: core_2.Input },],
        "suggestions": [{ type: core_2.Input },],
        "suggestionField": [{ type: core_2.Input },],
        "placeholder": [{ type: core_2.Input },],
        "readOnly": [{ type: core_2.Input },],
        "hideLabel": [{ type: core_2.Input },],
        "disabled": [{ type: core_2.Input },],
        "valueRadioButton": [{ type: core_2.Input },],
        "fechaMinima": [{ type: core_2.Input },],
        "fechaMaxima": [{ type: core_2.Input },],
        "calendarReadOnlyInput": [{ type: core_2.Input },],
        "instanciaPipe": [{ type: core_2.Input },],
        "completeMethod": [{ type: core_2.Output },],
        "onSelect": [{ type: core_2.Output },],
        "onChange": [{ type: core_2.Output },],
        "forceObligatorio": [{ type: core_2.Input },],
    };
    return BitInputComponent;
}());
exports.BitInputComponent = BitInputComponent;
//# sourceMappingURL=bit-input.component.js.map