"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var moment = require("moment");
//import moment = require("moment");  versión lógica por la forma en que se exporta moment desde moment.d.ts
var Subject_1 = require("rxjs/Subject");
var domain_1 = require("../data/domain");
var GeneralUtils = (function () {
    function GeneralUtils() {
        this.observableLoadingSource = new Subject_1.Subject();
        this.observableLoading = this.observableLoadingSource.asObservable();
    }
    GeneralUtils.prototype.startLoading = function () {
        console.log("start loading");
        this.observableLoadingSource.next("start");
    };
    GeneralUtils.prototype.stopLoading = function () {
        console.log("stop loading");
        this.observableLoadingSource.next("stop");
    };
    GeneralUtils.getTwoDigits = function (digit) {
        if (digit < 10) {
            return '0' + digit;
        }
        else {
            return '' + digit;
        }
    };
    GeneralUtils.getPathFromURL = function (segments) {
        var path = '';
        for (var _i = 0, segments_1 = segments; _i < segments_1.length; _i++) {
            var seg = segments_1[_i];
            path += seg.path;
            path += '/';
        }
        return path;
    };
    GeneralUtils.buildNombreCompleto = function (obj) {
        var str = '';
        if (obj.nombre)
            str += obj.nombre;
        if (obj.apellido1)
            str += (str.length > 0 ? ' ' : '') + obj.apellido1;
        if (obj.apellido2)
            str += (str.length > 0 ? ' ' : '') + obj.apellido2;
        return str;
    };
    GeneralUtils.getTodayAsString = function (format) {
        if (format === void 0) { format = GeneralUtils.FORMAT_SHORT_DATE; }
        return moment(new Date()).format(format);
    };
    GeneralUtils.getDateAsString = function (fecha, format) {
        if (format === void 0) { format = GeneralUtils.FORMAT_SHORT_DATE; }
        return moment(fecha).format(format);
    };
    GeneralUtils.getStringAsDate = function (fecha, format) {
        if (format === void 0) { format = GeneralUtils.FORMAT_SHORT_DATE; }
        return moment(fecha, format).toDate();
    };
    GeneralUtils.getDateTimeAsString = function (fecha, format) {
        if (format === void 0) { format = GeneralUtils.FORMAT_LONG_DATE; }
        return moment(fecha).format(format);
    };
    GeneralUtils.getTimeAsString = function (fecha, format) {
        if (format === void 0) { format = GeneralUtils.FORMAT_SHORT_TIME; }
        return moment(fecha).format(format);
    };
    GeneralUtils.stringToDate = function (fString) {
        return moment(fString).toDate();
    };
    GeneralUtils.stringShortToDate = function (fString) {
        return moment(fString, "DD/MM/YYYY").toDate();
    };
    GeneralUtils.stringToTime = function (tString) {
        return moment(tString, "HH:mm").toDate();
    };
    GeneralUtils.getTimeFromDateString = function (fecha) {
        return moment(fecha).format(GeneralUtils.FORMAT_SHORT_TIME);
    };
    GeneralUtils.getFirstDayOfCurrentMonth = function () {
        return moment().startOf('month').format(GeneralUtils.FORMAT_SHORT_DATE);
    };
    GeneralUtils.getLastDayOfCurrentMonth = function () {
        return moment().endOf('month').format(GeneralUtils.FORMAT_SHORT_DATE);
    };
    GeneralUtils.fechaInicioDespuesIgualFechaFin = function (fechaInicio, fechaFin) {
        if (fechaInicio && fechaFin) {
            return GeneralUtils.stringShortToDate(fechaInicio) > GeneralUtils.stringShortToDate(fechaFin);
        }
        return false;
    };
    GeneralUtils.horaInicioDespuesHoraFin = function (horaInicio, horaFin) {
        if (horaInicio && horaFin) {
            return GeneralUtils.stringToTime(horaInicio) > GeneralUtils.stringToTime(horaFin);
        }
        return false;
    };
    GeneralUtils.fechaEnRango = function (fecha, fechaInicio, fechaFin) {
        if (fecha) {
            var fechaDate = GeneralUtils.stringShortToDate(fecha);
            var output = !((fechaInicio && (fechaDate < GeneralUtils.stringShortToDate(fechaInicio)))
                || (fechaFin && (fechaDate > GeneralUtils.stringShortToDate(fechaFin))));
            return output;
        }
        return false;
    };
    GeneralUtils.addOpcionVacia = function (lista, texto) {
        lista.unshift(new domain_1.Domain(null, (texto ? texto : "")));
        return lista;
    };
    GeneralUtils.getOptionText = function (list, id) {
        for (var _i = 0, list_1 = list; _i < list_1.length; _i++) {
            var d = list_1[_i];
            if (+d.value == id) {
                return d.label;
            }
        }
        return "-";
    };
    GeneralUtils.FORMAT_SHORT_DATE = "DD/MM/YYYY";
    GeneralUtils.FORMAT_LONG_DATE = "DD/MM/YYYY HH:mm";
    GeneralUtils.FORMAT_SHORT_TIME = "HH:mm";
    GeneralUtils.FORMAT_SHORT_SECONDS_TIME = "HH:mm:ss";
    GeneralUtils.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    GeneralUtils.ctorParameters = function () { return []; };
    return GeneralUtils;
}());
exports.GeneralUtils = GeneralUtils;
//# sourceMappingURL=general-utils.service.js.map